//
//  GlowWormRegc.h
//  GlowWorm
//
//  Created by Curtis Jones on 2006.12.09.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <GlowWormObject.h>
#import <Transaction.h>

#define GW_REGC_VERSION			0x00020001

@interface GlowWormRegc : GlowWormObject <GlowWormObject>
{
	
}

- (id)init;
- (id)initWithValues:(NSDictionary *)values;

/* reg code info */
- (NSNumber *)enabled;
- (NSString *)product;
- (NSString *)version;
- (NSNumber *)expires;
- (NSString *)serial;

/* registrant information */
- (NSString *)email;
- (NSString *)fname;
- (NSString *)lname;
- (NSNumber *)account;

/* reg code data */
- (NSNumber *)hash;
- (NSNumber *)algo;
- (NSNumber *)data;
- (NSData   *)dsigr;
- (NSData   *)dsigs;
- (NSData   *)code;
- (NSNumber *)cleng;
- (NSNumber *)rleng;
- (NSNumber *)sleng;

/* reg code info */
- (void)setEnabled:(NSNumber *)aNum;
- (void)setProduct:(NSString *)aStr;
- (void)setVersion:(NSString *)aStr;
- (void)setExpires:(NSNumber *)aNum;
- (void)setSerial :(NSString *)aStr;

/* registrant information */
- (void)setEmail:(NSString *)aStr;
- (void)setFname:(NSString *)aStr;
- (void)setLname:(NSString *)aStr;
- (void)setAccount:(NSNumber *)aNum;

/* reg code data */
- (void)setHash:(NSNumber *)aNum;
- (void)setAlgo:(NSNumber *)aNum;
- (void)setData:(NSNumber *)aNum;
- (void)setDsigr:(NSData *)aData;
- (void)setDsigs:(NSData *)aData;
- (void)setCode:(NSData *)aData;
- (void)setCleng:(NSNumber *)aNum;
- (void)setRleng:(NSNumber *)aNum;
- (void)setSleng:(NSNumber *)aNum;

/* parsing functions */
- (BOOL)parseGood;
- (BOOL)parseData:(NSData *)aData;
+ (NSArray *)parseLines:(NSData *)aData;
- (void)populate:(NSArray *)lines;

/* kext helper functions */
+ (Transaction *)insertRegcChangeHandler:(id)callbackObj callbackSel:(SEL)callbackSel;
+ (Transaction *)deleteRegcChangeHandler:(id)callbackObj callbackSel:(SEL)callbackSel;
+ (Transaction *)insertRegc:(GlowWormRegc *)aRegc withBlocking:(BOOL)doBlocking callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)deleteRegc:(GlowWormRegc *)aRegc withBlocking:(BOOL)doBlocking callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)selectRegcWithBlocking:(BOOL)doBlocking callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;

	/* serialization functions */
- (NSData *)serialize;
- (int)deserialize:(NSData *)data offs:(int)offs;

@end
