//
//  GlowWormRule.h
//  GlowWorm
//
//  Created by Curtis Jones on 2006.09.13.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <GlowWormObject.h>
#import <GlowWormRuleAction.h>
#import <Transaction.h>

#define GWR_VERSION			0x00020009

@interface GlowWormNumb : NSObject <GlowWormObject>
{
	
}

- (id)init;
- (uint32_t)beg;
- (uint32_t)end;
- (void)setBeg:(uint32_t)anInt;
- (void)setEnd:(uint32_t)anInt;
- (NSString *)stringValue;
- (NSData *)serialize;
- (int)deserialize:(NSData *)data offs:(int)offs;

@end

@interface GlowWormAddr : GlowWormNumb <GlowWormObject>
{
	
}

- (NSString *)addr;
- (void)setAddr:(NSString *)anAddr;
- (BOOL)setStringValue:(NSString *)anAddr;

- (BOOL)hasAddress;
- (NSString *)stringValue;
- (NSData *)serialize;
- (int)deserialize:(NSData *)data offs:(int)offs;

@end

@interface GlowWormPort : GlowWormNumb
{
	
}

- (BOOL)setStringValue:(NSString *)aStr;
- (NSString *)stringValue;
- (NSString *)stringValue:(BOOL)showServiceName;

@end

@interface GlowWormExec : NSObject
{
	
}

- (NSString *)exec;
- (void)setExec:(NSString *)anExec;

@end

@interface GlowWormConn : GlowWormObject <GlowWormObject>
{
	
}

- (NSNumber *)enabled;
- (NSNumber *)position;
- (NSNumber *)endpoint;
- (NSNumber *)direction;
- (NSNumber *)protocol;
- (NSNumber *)socketid;
- (GlowWormAddr *)addr;
- (GlowWormPort *)port;

- (void)setEnabled:(NSNumber *)aNum;
- (void)setPosition:(NSNumber *)aNum;
- (void)setEndpoint:(NSNumber *)aNum;
- (void)setDirection:(NSNumber *)aNum;
- (void)setProtocol:(NSNumber *)aNum;
- (void)setSocketId:(NSNumber *)aNum;
- (void)setAddr:(GlowWormAddr *)anAddr;
- (void)setPort:(GlowWormPort *)aPort;

- (NSData *)serialize;
- (int)deserialize:(NSData *)data offs:(int)offs;


@end

@interface GlowWormRule : GlowWormObject <GlowWormObject>
{
	
}

- (NSString *)fancyAddressesWithServiceNames:(BOOL)useServiceNames;
- (void)recalcFancyAddresses;

+ (GlowWormRule *)ruleWithOnOff:(uint32_t)onoff
														log:(uint32_t)log
													 term:(uint32_t)term
													 list:(uint32_t)list
													 type:(uint32_t)type
													 call:(uint32_t)call
												 action:(uint32_t)action
											 throttle:(uint32_t)throttle
													stats:(uint32_t)stats
											 statfreq:(uint32_t)statfreq
											 position:(uint32_t)position
											 category:(uint32_t)category
											direction:(uint32_t)direction
													proto:(uint32_t)proto
											 socketid:(uint32_t)socketid
										 connection:(NSArray *)connection
										application:(NSString *)application;

+ (GlowWormRule *)ruleWithOnOff:(uint32_t)onoff
														log:(uint32_t)log
													 term:(uint32_t)term
													 list:(uint32_t)list
													 type:(uint32_t)type
													 call:(uint32_t)call
												 action:(uint32_t)action
											 throttle:(uint32_t)throttle
													stats:(uint32_t)stats
											 statfreq:(uint32_t)statfreq
											 position:(uint32_t)position
											 category:(uint32_t)category
											direction:(uint32_t)direction
													proto:(uint32_t)proto
											 socketid:(uint32_t)socketid
										 connection:(NSArray *)connection
										application:(NSString *)application
											process:(uint32_t)process;

- (NSNumber *)created;
- (NSNumber *)uniqueId;
- (NSNumber *)matchCount;
- (NSNumber *)onOff;
- (NSNumber *)listType;
- (NSNumber *)action;
- (NSNumber *)term;
- (NSNumber *)logging;
- (NSNumber *)pckts;
- (NSNumber *)stats;
- (NSNumber *)statFreq;
- (NSNumber *)position;
- (NSNumber *)category;
- (NSNumber *)boottime;
- (NSArray  *)application;
- (NSArray  *)user;
- (NSArray  *)group;
- (NSNumber *)ruleId;
- (NSArray  *)connection;
- (NSString *)interface;
- (NSNumber *)restrictval;
- (NSNumber *)mesgsize;
- (NSArray *)raction;
- (NSDate *)lastMatch;

- (void)setCreated:(NSNumber *)aNum;
- (void)setUniqueId:(NSNumber *)aNum;
- (void)setMatchCount:(NSNumber *)aNum;
- (void)incrementMatchCount:(NSNumber *)aNum;
- (void)setOnOff:(NSNumber *)aNum;
- (void)setListType:(NSNumber *)aNum;
- (void)setAction:(NSNumber *)aNum;
- (void)setTerm:(NSNumber *)aNum;
- (void)setLogging:(NSNumber *)aNum;
- (void)setPckts:(NSNumber *)aNum;
- (void)setStats:(NSNumber *)aNum;
- (void)setStatFreq:(NSNumber *)aNum;
- (void)setPosition:(NSNumber *)aNum;
- (void)setCategory:(NSNumber *)aNum;
- (void)setBootTime:(NSNumber *)aNum;
- (void)setApplication:(NSArray *)anArray;
- (void)setUser:(NSArray *)anArray;
- (void)setGroup:(NSArray *)anArray;
- (void)setRuleId:(NSNumber *)aNum;
- (void)setType:(NSNumber *)aNum;
- (void)setCall:(NSNumber *)aNum;
- (void)setConnection:(NSMutableArray *)anArray;
- (void)setInterface:(NSString *)aStr;
- (void)setProcess:(NSNumber *)aNum;
- (void)setRestrict:(NSNumber *)aNum;
- (void)setMesgSize:(NSNumber *)aNum;
- (void)setRaction:(NSMutableArray *)anArray;
- (void)setLastMatch:(NSDate *)aDate;
- (void)setLastMatchToNow;

- (GlowWormRuleAction *)ruleActionByType:(uint32_t)action;

+ (Transaction *)insertRuleHandler:(uint32_t)aList andTerm:(uint32_t)aTerm andType:(uint32_t)aType callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)insertRuleChangeHandlerForList:(uint32_t)aList andTerm:(uint32_t)aTerm callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel;
+ (Transaction *)insertRule:(GlowWormRule *)aRule withBlocking:(BOOL)doBlocking callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)updateRule:(GlowWormRule *)aRule withBlocking:(BOOL)doBlocking callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)deleteRule:(GlowWormRule *)aRule withBlocking:(BOOL)doBlocking callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)selectRule:(uint32_t)aRule list:(uint32_t)aList term:(uint32_t)aTerm callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel;

- (int)serializeNumb:(NSMutableData *)data forKey:(NSObject *)aKey;
- (int)serializeExec:(NSMutableData *)data forKey:(NSObject *)aKey;
- (int)deserializeNumb:(NSData *)data offs:(int)offs forKey:(NSObject *)aKey;
- (int)deserializeExec:(NSData *)data offs:(int)offs forKey:(NSObject *)aKey;

- (int)deserialize_2_9:(NSData *)data offs:(int)offs;
- (int)deserialize_2_8:(NSData *)data offs:(int)offs;
- (int)deserialize_2_7:(NSData *)data offs:(int)offs;
- (int)deserialize_2_6:(NSData *)data offs:(int)offs;
- (int)deserialize_2_5:(NSData *)data offs:(int)offs;
- (int)deserialize_2_4:(NSData *)data offs:(int)offs;
- (int)deserialize_2_3:(NSData *)data offs:(int)offs;
- (int)deserialize_2_2:(NSData *)data offs:(int)offs;
- (int)deserialize_2_1:(NSData *)data offs:(int)offs;

@end
