//
//  GlowWormSock.h
//  GlowWorm
//
//  Created by Curtis Jones on 2006.09.13.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <sys/types.h>
#import <GlowWormMesg.h>
#import <GlowWormObject.h>
#import <Transaction.h>

@interface GlowWormSock : GlowWormObject <GlowWormObject>
{
	
}

- (id)init;


- (NSNumber *)getUniqueId;			// uint32_t - unique identifier for connection

- (NSNumber *)getProtocol;			// uint32_t - socket protocol (tcp, dup)
- (NSNumber *)getDirection;			// uint32_t - incoming or outgoing

- (NSNumber *)getProcessId;			// uint32_t - owner process id
- (NSNumber *)getUserId;				// uint32_t - owner user id
- (NSString *)getApplication;		// string		- executable path

- (NSNumber *)getRemotePort;		// uint32_t - remote endpoint port
- (NSNumber *)getLocalPort;			// uint32_t - local endpoint port
- (NSNumber *)getRemoteAddr;		// uint32_t - remote endpoint address
- (NSNumber *)getLocalAddr;			// uint32_t - local endpoint address
- (NSString *)getLocalName;			// string		- local endpoint host name
- (NSString *)getRemoteName;		// string		- remote endpoint host name
- (NSString *)getInterface;			// string		- interface name

- (NSNumber *)getBytesSend;			// uint64_t - bytes sent
- (NSNumber *)getBytesRecv;			// uint64_t - bytes received
- (NSNumber *)getPcktsSend;			// uint64_t - packets sent
- (NSNumber *)getPcktsRecv;			// uint64_t - packets received


- (void)setUniqueId:(uint32_t)val;

- (void)setProtocol:(uint32_t)val;
- (void)setDirection:(uint32_t)val;

- (void)setProcessId:(uint32_t)val;
- (void)setUserId:(uint32_t)val;
- (void)setApplication:(NSString *)aStr;

- (void)setRemotePort:(uint32_t)val;
- (void)setLocalPort:(uint32_t)val;
- (void)setRemoteAddr:(uint32_t)val;
- (void)setLocalAddr:(uint32_t)val;
- (void)setLocalName:(NSString *)aStr;
- (void)setRemoteName:(NSString *)aStr;
- (void)setInterface:(NSString *)aStr;

- (NSString *)getLocalAddrReadable;
- (NSString *)getRemoteAddrReadable;
- (NSString *)getLocation;
- (void)setLocation:(NSString *)loca;
- (NSString *)getReverseDns;
- (void)setReverseDns:(NSString *)rdns;

+ (Transaction *)sockSelect:(uint32_t)sock callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel;
+ (void)connAuthAllow:(GlowWormMesg *)aMesg;
+ (void)connAuthDeny:(GlowWormMesg *)aMesg;
+ (void)connAuthDefer:(GlowWormMesg *)aMesg;
+ (void)connAuth:(uint32_t)anAction mesg:(GlowWormMesg *)aMesg;

@end
